//------------------------------------
float alpha;
texture sceneRendering;


//------------------------------------
struct vertexInput {
    float3 position				: POSITION;
    float4 texCoord				: TEXCOORD0;
};

struct vertexOutput {
    float4 HPosition 			: POSITION;
    float4 ColorTextureCoord	: TEXCOORD0;
};

struct pixelOutput
{
	float4 color				: COLOR;
};

//------------------------------------
#define SAMPLER_LINEAR(g_samplerMap, g_txMap);	\
	sampler2D g_samplerMap = sampler_state {	\
    Texture = <g_txMap>;						\
    MinFilter = Linear;							\
    MagFilter = Linear;							\
    MipFilter = Linear;							\
    AddressU  = BORDER;							\
    AddressV  = BORDER;							\
};

#define SAMPLER_POINT(g_samplerMap, g_txMap);	\
	sampler2D g_samplerMap = sampler_state {	\
    Texture = <g_txMap>;						\
    MinFilter = Point;							\
    MagFilter = Point;							\
    MipFilter = Point;							\
    AddressU  = BORDER;							\
    AddressV  = BORDER;							\
};

SAMPLER_POINT(samplerSceneRendering,	sceneRendering);

//------------------------------------
vertexOutput fadeVS(vertexInput IN) 
{
    vertexOutput OUT;
    
    OUT.HPosition = float4(IN.position,1);
    OUT.ColorTextureCoord = IN.texCoord;

    return OUT;
}


//------------------------------------
pixelOutput fadePS(vertexOutput IN)
{
	pixelOutput OUT;
	
	// Do a lookup in the depth buffer.
	float4 retColor = tex2D(samplerSceneRendering, IN.ColorTextureCoord.xy);
	retColor.a = alpha;
	//float4 retColor = float4(0.4, 1, 0, 1);
	OUT.color = retColor;
	
	return OUT;
}



// 
// Effect
//

#define Technique(name);								\
	technique name										\
	{													\
	    pass p0											\
	    {												\
		    VertexShader = compile vs_1_1 name##VS();	\
		    PixelShader  = compile ps_1_1 name##PS();	\
		}												\
	}
	
Technique( fade );